diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 5bbd895c..2c22886c 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -825,38 +1167,32 @@ class SquadService extends Actor {
           //the following action can be performed by anyone who has tried to join a squad
           case (_, CancelSelectRoleForYourself(_)) =>
             val cancellingPlayer = tplayer.CharId
-            idToSquad.get(guid) match {
+            GetSquad(guid) match {
               case Some(squad) =>
                 //assumption: a player who is cancelling will rarely end up with their invite queued
                 val leaderCharId = squad.Leader.CharId
-                //clean up any active BidForPosition invite entry where we are the player who wants to join the leader's squad
+                //clean up any active BidForRole invite entry where we are the player who wants to join the leader's squad
                 ((invites.get(leaderCharId) match {
-                  case out @ Some(entry) if entry.isInstanceOf[BidForPosition] &&
-                    entry.asInstanceOf[BidForPosition].player.CharId == cancellingPlayer =>
+                  case out @ Some(entry) if entry.isInstanceOf[BidForRole] &&
+                    entry.asInstanceOf[BidForRole].player.CharId == cancellingPlayer =>
                     out
                   case _ =>
                     None
                 }) match {
-                  case Some(entry : BidForPosition) =>
+                  case Some(entry : BidForRole) =>
                     RemoveInvite(leaderCharId)
                     SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
-                    NextInvite(leaderCharId) match {
-                      case Some(bid : BidForPosition) =>
-                        HandleBidForPosition(bid, tplayer)
-                      case Some(bid) =>
-                        SquadEvents.publish(SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bid.InviterCharId, Some(leaderCharId), bid.InviterName, false, Some(None))))
-                      case _ => ;
-                    }
+                    NextInviteAndRespond(leaderCharId)
                     Some(true)
                   case _ =>
                     None
                 }).orElse(
-                  //look for a queued BidForPosition entry where we are the player who wants to join the leader's squad
+                  //look for a queued BidForRole entry where we are the player who wants to join the leader's squad
                   (queuedInvites.get(leaderCharId) match {
                     case Some(_list) =>
                       (_list, _list.indexWhere { entry =>
-                        entry.isInstanceOf[BidForPosition] &&
-                          entry.asInstanceOf[BidForPosition].player.CharId == cancellingPlayer
+                        entry.isInstanceOf[BidForRole] &&
+                          entry.asInstanceOf[BidForRole].player.CharId == cancellingPlayer
                       })
                     case None =>
                       (Nil, -1)
@@ -864,12 +1200,12 @@ class SquadService extends Actor {
                     case (_, -1) =>
                       None //no change
                     case (list, index) if list.size == 1 =>
-                      val entry = list.head.asInstanceOf[BidForPosition]
+                      val entry = list.head.asInstanceOf[BidForRole]
                       SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
                       queuedInvites.remove(leaderCharId)
                       Some(true)
                     case (list, index) =>
-                      val entry = list(index).asInstanceOf[BidForPosition]
+                      val entry = list(index).asInstanceOf[BidForRole]
                       SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
                       queuedInvites(leaderCharId) = list.take(index) ++ list.drop(index+1)
                       Some(true)
@@ -905,23 +1241,22 @@ class SquadService extends Actor {
             }
 
           //the following action can be peprformed by anyone
-          case (_, SearchForSquadsWithParticularRole(role, requirements, zone_id, search_mode)) =>
+          case (_, SearchForSquadsWithParticularRole(_/*role*/, _/*requirements*/, _/*zone_id*/, _/*search_mode*/)) =>
             //though we should be able correctly search squads as is intended
             //I don't know how search results should be prioritized or even how to return search results to the user
             sender ! SquadServiceResponse("", SquadResponse.SquadSearchResults())
 
           //the following action can be performed by anyone
           case (_, DisplaySquad()) =>
-            idToSquad.get(guid) match {
+            GetSquad(guid) match {
               case Some(squad) =>
-                viewDetails(tplayer.CharId) = guid
                 sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
               case None => ;
             }
 
           //the following message is feedback from a specific client, awaiting proper initialization
           case (_, SquadMemberInitializationIssue()) =>
-//            idToSquad.get(guid) match {
+//            GetSquad(guid) match {
 //              case Some(squad) =>
 //                sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
 //              case None => ;
@@ -958,54 +1293,65 @@ class SquadService extends Actor {
   }
 
   /**
-    *
-    * @param invitedPlayer
-    * @param bid
+    * na
+    * @param invitedPlayer the person who will handle the invitation, eventually if not immediately
+    * @param invite the "new" invitation envelop object
     * @return an optional invite;
     *         if added to the active invite position, return the parameter bid;
     *         if added to the queued invite, return the invite in the active position;
     *         if not added, return `None`
     */
-  def AddInvite(invitedPlayer : Long, bid : Invitation) : Option[Invitation] = {
-    invites.get(invitedPlayer) match {
+  def AddInvite(invitedPlayer : Long, invite : Invitation) : Option[Invitation] = {
+    invites.get(invitedPlayer).orElse(previousInvites.get(invitedPlayer)) match {
       case Some(_bid) =>
+        //the active invite does not interact with the given invite; add to queued invites
         queuedInvites.get(invitedPlayer) match {
           case Some(bidList) =>
-            if(_bid.InviterCharId != bid.InviterCharId && !bidList.exists { eachBid => eachBid.InviterCharId == bid.InviterCharId }) {
-              log.debug(s"Invite from ${bid.InviterCharId} to $invitedPlayer stored in queue while active invite request pending")
-              queuedInvites(invitedPlayer) = bid match {
-                case _: BidForPosition =>
-                  val (normals, others) = bidList.partition(_.isInstanceOf[BidForPosition])
-                  (normals :+ bid) ++ others
+            //ensure that new invite does not interact with the queue's invites by invitingPlayer info
+            if(_bid.InviterCharId != invite.InviterCharId && !bidList.exists { eachBid => eachBid.InviterCharId == invite.InviterCharId }) {
+              log.debug(s"Invite from ${invite.InviterCharId} to $invitedPlayer stored in queue while active invite request pending")
+              queuedInvites(invitedPlayer) = invite match {
+                case _: BidForRole =>
+                  val (normals, others) = bidList.partition(_.isInstanceOf[BidForRole])
+                  (normals :+ invite) ++ others
                 case _ =>
-                  bidList :+ bid
+                  bidList :+ invite
               }
-              None
-            }
-            else {
               Some(_bid)
             }
-          case None =>
-            if(_bid.InviterCharId != bid.InviterCharId) {
-              log.debug(s"Invite from ${bid.InviterCharId} to $invitedPlayer stored while active invite request pending")
-              queuedInvites(invitedPlayer) = List[Invitation](bid)
+            else {
+              None
+            }
+          case None =>
+            if(_bid.InviterCharId != invite.InviterCharId) {
+              log.debug(s"Invite from ${invite.InviterCharId} to $invitedPlayer stored while active invite request pending")
+              queuedInvites(invitedPlayer) = List[Invitation](invite)
+              Some(_bid)
+            }
+            else {
+              None
             }
-            Some(_bid)
         }
 
       case None =>
-        invites(invitedPlayer) = bid
-        Some(bid)
+        invites(invitedPlayer) = invite
+        Some(invite)
     }
   }
 
   def RemoveInvite(invitedPlayer : Long) : Option[Invitation] = {
-    invites.remove(invitedPlayer)
+    invites.remove(invitedPlayer) match {
+      case out @ Some(invite) =>
+        previousInvites += invitedPlayer -> invite
+        out
+      case None =>
+        None
+    }
   }
 
   def RemoveQueuedInvites(invitedPlayer : Long) : List[Invitation] = {
     queuedInvites.remove(invitedPlayer) match {
-      case Some(_bidList) => _bidList.toList
+      case Some(_bidList) => _bidList
       case None => Nil
     }
   }
@@ -1032,6 +1378,7 @@ class SquadService extends Actor {
   }
 
   def NextInvite(invitedPlayer : Long) : Option[Invitation] = {
+    previousInvites.remove(invitedPlayer)
     invites.get(invitedPlayer) match {
       case None =>
         queuedInvites.get(invitedPlayer) match {
@@ -1059,7 +1406,7 @@ class SquadService extends Actor {
 
   def HandleVacancyInvite(squad_guid : PlanetSideGUID, invitedPlayer : Long, invitingPlayer : Long, recruit : Player) : Option[(Squad, Int)] = {
     //accepted an invitation to join an existing squad
-    if(idToSquad.get(squad_guid).isEmpty) {
+    if(squadFeatures.get(squad_guid).isEmpty) {
       log.warn(s"Accept->Invite: the squad #${squad_guid.guid} no longer exists")
       None
     }
@@ -1068,16 +1415,15 @@ class SquadService extends Actor {
       None
     }
     else {
-      val squad = idToSquad(squad_guid)
+      val squad = squadFeatures(squad_guid).Squad
       if(!squad.AutoApproveInvitationRequests && squad.Leader.CharId != invitingPlayer) {
         //the inviting player was not the squad leader and this decision should be bounced off the squad leader
-        val bid = IndirectVacancy(recruit, squad_guid)
-        AddInvite(squad.Leader.CharId, bid) match {
-          case out @ Some(_) if out.contains(bid) =>
-            SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), recruit.Name, false, Some(None))))
-            HandleBidForPosition(bid, recruit)
-          case _ => ;
-        }
+        AltAddInviteAndRespond(
+          squad.Leader.CharId,
+          IndirectInvite(recruit, squad_guid),
+          invitingPlayer,
+          name = ""
+        )
         log.info(s"Accept->Invite: ${recruit.Name} must await an invitation from the leader of squad #${squad_guid.guid}")
         None
       }
@@ -1103,44 +1449,44 @@ class SquadService extends Actor {
 
   def InitialAssociation(squad : Squad) : Boolean = {
     val guid = squad.GUID
-    initialAssociation.indexOf(guid) match {
-      case -1 => ;
-      case index =>
-        initialAssociation.remove(index)
-        val charId = squad.Leader.CharId
-        SquadEvents.publish(
-          SquadServiceResponse(s"/$charId/Squad", SquadResponse.AssociateWithSquad(guid))
-        )
-        SquadEvents.publish(
-          SquadServiceResponse(s"/$charId/Squad", SquadResponse.Detail(
-            guid,
-            SquadService.Detail.Publish(squad))
-          )
+    if(squadFeatures(guid).InitialAssociation) {
+      squadFeatures(guid).InitialAssociation = false
+      val charId = squad.Leader.CharId
+      SquadEvents.publish(
+        SquadServiceResponse(s"/$charId/Squad", SquadResponse.AssociateWithSquad(guid))
+      )
+      SquadEvents.publish(
+        SquadServiceResponse(s"/$charId/Squad", SquadResponse.Detail(
+          guid,
+          SquadService.Detail.Publish(squad))
         )
+      )
     }
     false
   }
 
-  def HandleBidForPosition(bid : BidForPosition, player : Player) : Unit = {
-    HandleBidForPosition(bid, bid.squad_guid, bid.player.Name, player)
+  def HandleBidForRole(bid : BidForRole, player : Player) : Boolean = {
+    HandleBidForRole(bid, bid.squad_guid, bid.player.Name, player)
   }
-  def HandleBidForPosition(bid : IndirectVacancy, player : Player) : Unit = {
-    HandleBidForPosition(bid, bid.squad_guid, bid.player.Name, player)
+  def HandleBidForRole(bid : IndirectInvite, player : Player) : Boolean = {
+    HandleBidForRole(bid, bid.squad_guid, bid.player.Name, player)
   }
 
-  def HandleBidForPosition(bid : Invitation, squad_guid : PlanetSideGUID, name : String, player : Player) : Unit = {
-    idToSquad.get(squad_guid) match {
+  def HandleBidForRole(bid : Invitation, squad_guid : PlanetSideGUID, name : String, player : Player) : Boolean = {
+    GetSquad(squad_guid) match {
       case Some(squad) =>
         val leaderCharId = squad.Leader.CharId
         if(squad.AutoApproveInvitationRequests) {
-          self ! SquadServiceMessage(player, SquadAction.Membership(SquadRequestType.Accept, leaderCharId, None, "", None))
+          self ! SquadServiceMessage(player, Zone.Nowhere, SquadAction.Membership(SquadRequestType.Accept, leaderCharId, None, "", None))
         }
         else {
           SquadEvents.publish(SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.WantsSquadPosition(name)))
         }
+        true
       case _ =>
         //squad is missing; will this properly short-circuit?
         log.error(s"Attempted to process ${bid.InviterName}'s bid for a position in a squad (id:${squad_guid.guid}) that does not exist")
+        false
     }
   }
 
@@ -1201,27 +1547,31 @@ class SquadService extends Actor {
     }
   }
 
-  def LeaveSquad(player : Player, squad : Squad) : Boolean = {
-    val charId = player.CharId
-    val membership = squad.Membership.zipWithIndex
-    membership.find { case (_member, _) => _member.CharId == charId } match {
-      case Some((member, index)) =>
-        val updateList = membership.collect({ case (_member, _index) if _member.CharId > 0 => (_member.CharId, _index) }).toList
-        //member leaves the squad completely
-        memberToSquad.remove(charId)
-        member.Name = ""
-        member.CharId = 0
-        sender ! SquadServiceResponse("", SquadResponse.Leave(squad, updateList))
-        //other squad members see the member leaving
-        val leavingMember = List((charId, index))
-        membership
-          .filter { case (_member, _) => _member.CharId > 0 }
-          .foreach { case (_member, _) =>
-            SquadEvents.publish( SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.Leave(squad, leavingMember)) )
-          }
-        true
-      case None =>
-        false
+  def RemoveInvitesForSquadAndPosition(guid : PlanetSideGUID, position : Int) : Unit = {
+    //eliminate active invites for this role
+    invites.collect {
+      case(charId, InviteForRole(_,_, sguid, pos)) if sguid == guid && pos == position =>
+        RemoveInvite(charId)
+      case (charId, BidForRole(_, sguid, pos)) if sguid == guid && pos == position =>
+        RemoveInvite(charId)
+    }
+    RemoveQueuedInvitesForSquadAndPosition(guid, position)
+  }
+
+  def RemoveQueuedInvitesForSquadAndPosition(guid : PlanetSideGUID, position : Int) : Unit = {
+    //eliminate other invites for this role
+    queuedInvites.foreach { case(charId, queue) =>
+      val filtered = queue.filterNot {
+        case InviteForRole(_,_, sguid, pos) => sguid == guid && pos == position
+        case BidForRole(_, sguid, pos) => sguid == guid && pos == position
+        case _ => false
+      }
+      if(filtered.isEmpty) {
+        queuedInvites.remove(charId)
+      }
+      else if(queue.size != filtered.size) {
+        queuedInvites += charId -> filtered
+      }
     }
   }
 
@@ -1230,7 +1580,7 @@ class SquadService extends Actor {
       case None =>
         true
       case Some(squad) if squad.Size == 1 =>
-        CloseOutSquad(squad)
+        CloseSquad(squad)
         true
       case _ =>
         log.warn(msg)
@@ -1238,27 +1588,169 @@ class SquadService extends Actor {
     }
   }
 
-  def CloseOutSquad(squad : Squad) : Unit = {
+  def LeaveSquad(charId : Long, squad : Squad) : Boolean = {
     val membership = squad.Membership.zipWithIndex
-    CloseOutSquad(
-      squad,
-      membership,
-      membership.collect({ case (_member, _index) if _member.CharId > 0 => (_member.CharId, _index) }).toList
-    )
+    membership.find { case (_member, _) => _member.CharId == charId } match {
+      case Some((member, index)) =>
+        val entry = (charId, index)
+        val updateList = entry +: membership
+          .collect { case (_member, _index) if _member.CharId > 0 && _member.CharId != charId => (_member.CharId, _index) }
+          .toList
+        //member leaves the squad completely
+        memberToSquad.remove(charId)
+        member.Name = ""
+        member.CharId = 0
+        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Leave(squad, updateList)))
+        //other squad members see the member leaving
+        val leavingMember = List(entry)
+        membership
+          .filter { case (_member, _) => _member.CharId > 0 }
+          .foreach { case (_member, _) =>
+            SquadEvents.publish( SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.Leave(squad, leavingMember)) )
+          }
+        UpdateSquadListWhenListed(squad, SquadInfo().Size(squad.Size))
+        UpdateSquadDetail(squad.GUID, squad,
+          SquadDetail().Members(List(SquadPositionEntry(index, SquadPositionDetail().Player(char_id = 0, name = ""))))
+        )
+        true
+      case None =>
+        false
+    }
   }
 
-  def CloseOutSquad(squad : Squad, membership : Iterable[(Member, Int)], updateList : List[(Long, Int)]) : Unit = {
-    membership.foreach {
-      case (member, _) =>
-        val charId = member.CharId
+  def CloseSquad(squad : Squad) : Unit = {
+    val guid = squad.GUID
+    val membership = squad.Membership.zipWithIndex
+    val (updateMembers, updateIndices) = membership
+      .collect { case (member, index) if member.CharId > 0 => ((member, member.CharId, index), (member.CharId, index)) }
+      .unzip
+    val updateIndicesList = updateIndices.toList
+    val completelyBlankSquadDetail = SquadDetail().Complete
+    updateMembers
+      .foreach { case (member, charId, index) =>
+        memberToSquad.remove(charId)
         member.Name = ""
         member.CharId = 0L
-        memberToSquad.remove(charId)
-        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Leave(squad, updateList)) )
+        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Leave(squad,
+          updateIndicesList.filterNot { case (_, outIndex) => outIndex == index } :+ (charId, index) //we need to be last to leave to see the events
+        )) )
+        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.AssociateWithSquad(PlanetSideGUID(0))) )
+        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Detail(PlanetSideGUID(0), completelyBlankSquadDetail)) )
+      }
+    UpdateSquadListWhenListed(squad, None)
+    CleanupInvitesForSquad(guid)
+    squadFeatures.remove(guid).get.Stop
+    TryResetSquadId()
+  }
+
+  def DisbandSquad(squad : Squad) : Unit = {
+    CloseSquad(squad)
+    val leader = squad.Leader.CharId
+    SquadEvents.publish(SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, leader, None, "", true, Some(None))))
+    squad.Membership
+      .collect { case member if member.CharId > 0 && member.CharId != leader => member.CharId }
+      .foreach { charId =>
+        SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None))))
+      }
+  }
+
+  def CleanupInvitesForSquad(squadGUID : PlanetSideGUID) : Unit = {
+    //clean up invites
+    invites.collect {
+      case (id, VacancyInvite(_, _, guid)) if squadGUID == guid =>
+        RemoveInvite(id)
+      case (id, IndirectInvite(_, guid)) if squadGUID == guid =>
+        RemoveInvite(id)
+      case (id, InviteForRole(_, _, guid, _)) if squadGUID == guid =>
+        RemoveInvite(id)
+      case (id, BidForRole(_, guid, _)) if squadGUID == guid =>
+        RemoveInvite(id)
+      case (id, ProximityInvite(_, _, guid)) if squadGUID == guid =>
+        RemoveInvite(id)
+    }
+    //tidy the queued invitations
+    queuedInvites.foreach { case(id, queue) =>
+      val filteredQueue = queue.filterNot {
+        case VacancyInvite(_, _, guid) => squadGUID == guid
+        case IndirectInvite(_, guid) => squadGUID == guid
+        case InviteForRole(_, _, guid, _) => squadGUID == guid
+        case BidForRole(_, guid, _) => squadGUID == guid
+        case ProximityInvite(_, _, guid) => squadGUID == guid
+        case _ => false
+      }
+      if(filteredQueue.isEmpty) {
+        queuedInvites.remove(id)
+      }
+      else if(filteredQueue.size != queue.size) {
+        queuedInvites.update(id, filteredQueue)
+      }
+    }
+    squadFeatures(squadGUID).SearchForRole match {
+      case None => ;
+      case Some(_) =>
+        squadFeatures(squadGUID).SearchForRole = None
+    }
+  }
+
+  def CleanupInvitesFromPlayer(charId : Long) : Unit = {
+    invites.remove(charId)
+    invites.collect {
+      case (id, SpontaneousInvite(player)) if player.CharId == charId =>
+        RemoveInvite(id)
+      case (id, VacancyInvite(_charId, _, _)) if _charId == charId =>
+        RemoveInvite(id)
+      case (id, IndirectInvite(player, _)) if player.CharId == charId =>
+        RemoveInvite(id)
+      case (id, InviteForRole(_charId, _, _, _)) if _charId == charId =>
+        RemoveInvite(id)
+      case (id, BidForRole(player, _, _)) if player.CharId == charId =>
+        RemoveInvite(id)
+      case (id, ProximityInvite(_charId, _, _)) if charId == _charId =>
+        RemoveInvite(id)
+    }
+    //tidy the queued invitations
+    queuedInvites.remove(charId)
+    queuedInvites.foreach { case(id, queue) =>
+      val filteredQueue = queue.filterNot {
+        case SpontaneousInvite(player) => player.CharId == charId
+        case VacancyInvite(player, _, _) => player == charId
+        case IndirectInvite(player, _) => player.CharId == charId
+        case InviteForRole(player, _, _, _) => player == charId
+        case BidForRole(player, _, _) => player.CharId == charId
+        case ProximityInvite(_charId, _, _) => _charId == charId
+        case _ => false
+      }
+      if(filteredQueue.isEmpty) {
+        queuedInvites.remove(id)
+      }
+      else if(filteredQueue.size != queue.size) {
+        queuedInvites.update(id, filteredQueue)
+      }
+    }
+    previousInvites.remove(charId)
+  }
+
+  def CleanupInvitesToPosition(position : Int) : Unit = {
+    invites.collect {
+      case (id, InviteForRole(_, _, _, _position)) if _position == position =>
+        RemoveInvite(id)
+      case (id, BidForRole(_, _, _position)) if _position == position =>
+        RemoveInvite(id)
+    }
+    //tidy the queued invitations
+    queuedInvites.foreach { case(id, queue) =>
+      val filteredQueue = queue.filterNot {
+        case InviteForRole(_, _, _, _position) => _position == position
+        case BidForRole(_, _, _position) => _position == position
+        case _ => false
+      }
+      if(filteredQueue.isEmpty) {
+        queuedInvites.remove(id)
+      }
+      else if(filteredQueue.size != queue.size) {
+        queuedInvites.update(id, filteredQueue)
+      }
     }
-    idToSquad.remove(squad.GUID)
-    waypoints.remove(squad.GUID)
-    UpdateSquadList(squad, None)
   }
 
   def SwapMemberPosition(squad : Squad, toMember : Member, fromMember : Member) : Unit = {
@@ -1375,18 +1867,7 @@ class SquadService extends Actor {
   }
 
   def AddWaypoint(guid : PlanetSideGUID, waypointType : Int, info : WaypointInfo) : Option[WaypointData] = {
-    (waypoints.get(guid) match {
-      case Some(array) =>
-        array
-      case None if idToSquad.get(guid).nonEmpty =>
-        log.debug(s"initializing squad waypoint system for squad #${guid.guid}")
-        val array = Array.fill[WaypointData](5)(new WaypointData())
-        waypoints(guid) = array
-        array
-      case _ =>
-        log.warn(s"squad #${guid.guid} does not currently exist so it can not render waypoints")
-        Array.empty[WaypointData]
-    }).lift(waypointType) match {
+    squadFeatures(guid).Waypoints.lift(waypointType) match {
       case Some(point) =>
         //update the waypoint
         log.debug(s"rendering squad waypoint $waypointType for squad #${guid.guid}")
@@ -1400,25 +1881,28 @@ class SquadService extends Actor {
   }
 
   def RemoveWaypoint(guid : PlanetSideGUID, waypointType : Int) : Unit = {
-    (waypoints.get(guid) match {
-      case Some(array) =>
-        array
-      case None =>
-        Array.empty[WaypointData]
-    }).lift(waypointType) match {
-      case Some(point) =>
-        //update the waypoint
-        log.debug(s"removing squad waypoint $waypointType for squad #${guid.guid}")
-        point.zone_number = 1
-        point.pos = Vector3.z(1)
-      case _ => ;
+    squadFeatures.get(guid) match {
+      case Some(features) =>
+        features.Waypoints.lift(waypointType) match {
+          case Some(point) =>
+            //update the waypoint
+            log.debug(s"removing squad waypoint $waypointType for squad #${guid.guid}")
+            point.zone_number = 1
+            point.pos = Vector3.z(1)
+          case _ =>
+            log.warn(s"no squad waypoint $waypointType found")
+        }
+      case _ =>
+        log.warn(s"no squad #$guid found")
     }
   }
 
   def InitWaypoints(toCharId : Long, guid : PlanetSideGUID) : Unit = {
-    (idToSquad.get(guid), waypoints.get(guid)) match {
-      case (Some(squad), Some(list)) =>
-        val vz1 = Vector3.z(1)
+    squadFeatures.get(guid) match {
+      case Some(features) =>
+        val squad = features.Squad
+        val vz1 = Vector3.z(value = 1)
+        val list = features.Waypoints
         SquadEvents.publish(
           SquadServiceResponse(s"/$toCharId/Squad", SquadResponse.InitWaypoints(squad.Leader.CharId,
             list.zipWithIndex.collect { case (point, index) if point.pos != vz1 =>
@@ -1426,7 +1910,81 @@ class SquadService extends Actor {
             }
           ))
         )
-      case _ => ;
+      case None => ;
+    }
+  }
+
+  def indirectInviteResp(bid : IndirectInvite, player : Player, invitedPlayer : Long, invitingPlayer : Long, name : String) : Boolean = {
+    HandleBidForRole(bid, player)
+  }
+
+  def altIndirectInviteResp(bid : IndirectInvite, player : Player, invitedPlayer : Long, invitingPlayer : Long, name : String) : Boolean = {
+    SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), player.Name, false, Some(None))))
+    HandleBidForRole(bid, player)
+  }
+
+  def InviteResponseTemplate(indirectVacancyFunc : (IndirectInvite, Player, Long, Long, String) => Boolean)(targetInvite : Invitation, actualInvite : Option[Invitation], invitedPlayer : Long, invitingPlayer : Long, name : String) : Unit = {
+    if(actualInvite.contains(targetInvite)) {
+      //immediately respond
+      targetInvite match {
+        case VacancyInvite(charId, _name, _) =>
+          SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, charId, Some(invitedPlayer), _name, false, Some(None))))
+          SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, true, Some(None))))
+
+        case _bid @ IndirectInvite(player, _) =>
+          indirectVacancyFunc(_bid, player, invitedPlayer, invitingPlayer, name)
+
+        case _bid @ SpontaneousInvite(player) =>
+          val bidInvitingPlayer = _bid.InviterCharId
+          SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bidInvitingPlayer, Some(invitedPlayer), player.Name, false, Some(None))))
+          SquadEvents.publish(SquadServiceResponse(s"/$bidInvitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(bidInvitingPlayer), player.Name, true, Some(None))))
+
+        case _bid @ BidForRole(player, _, _) =>
+          HandleBidForRole(_bid, player)
+
+        case InviteForRole(charId, _name, _, _) =>
+          SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, false, Some(None))))
+
+        case ProximityInvite(charId, _name, _) =>
+          SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, false, Some(None))))
+
+        case _ =>
+          log.warn(s"AddInviteAndRespond: can not parse discovered unhandled invitation type - $targetInvite")
+      }
+    }
+  }
+
+  def AddInviteAndRespond(invitedPlayer : Long, targetInvite : Invitation, invitingPlayer : Long, name : String) : Unit = {
+    InviteResponseTemplate(indirectInviteResp)(
+      targetInvite,
+      AddInvite(invitedPlayer, targetInvite),
+      invitedPlayer,
+      invitingPlayer,
+      name
+    )
+  }
+
+  def AltAddInviteAndRespond(invitedPlayer : Long, targetInvite : Invitation, invitingPlayer : Long, name : String) : Unit = {
+    InviteResponseTemplate(altIndirectInviteResp)(
+      targetInvite,
+      AddInvite(invitedPlayer, targetInvite),
+      invitedPlayer,
+      invitingPlayer,
+      name
+    )
+  }
+
+  def NextInviteAndRespond(invitedPlayer : Long) : Unit = {
+    NextInvite(invitedPlayer) match {
+      case Some(invite) =>
+        InviteResponseTemplate(indirectInviteResp)(
+          invite,
+          Some(invite),
+          invitedPlayer,
+          invite.InviterCharId,
+          invite.InviterName
+        )
+      case None => ;
     }
   }
 }
